IF EXISTS ( SELECT * 
            FROM   sysobjects 
            WHERE  id = object_id(N'dbo.CP_Compras_por_Producto') 
                   and OBJECTPROPERTY(id, N'IsProcedure') = 1 )
BEGIN
    DROP PROCEDURE dbo.CP_Compras_por_Producto 
END
GO 

CREATE PROCEDURE dbo.CP_Compras_por_Producto
	@pFecha_Desde			DATETIME,
	@pFecha_Hasta			DATETIME,
	@pFamilia               Int,
	@pProveedor             Int,
	@pMonto_Total           Decimal(14,2),
    @descrip                CHAR(100)
	 
AS
SET NOCOUNT ON

/*Declaracion Variables Locales*/

DECLARE @Mensaje			VARCHAR(100)
		,@UltError			INT
		,@Id_Trans			INT
		,@Id_Cliente		INT
		,@Importe			DECIMAL(16,2)
		,@Email_Cob			VARCHAR(256)
		,@Id_Trans_Rec		INT
		,@CursorOpen        INT
		,@Flag_Cbte_Tipo	SMALLINT
		,@Periodo           DATE 
		,@Id_sucursal	    SMALLINT
		,@Existe      	    SMALLINT
		,@Venta_Total       DECIMAL(16,2)

IF RTRIM(LTRIM(isnull(@descrip,''))) = '' 
   BEGIN
    set @descrip = '% %'
   END
ELSE
   BEGIN
    set @descrip = '%'+ltrim(rtrim(@Descrip))+'%' 
   END   

					
BEGIN 
    SET @Venta_Total = @pMonto_Total
    IF @pMonto_Total = 0
       BEGIN
		IF @pProveedor = 0
			BEGIN
               set @Venta_Total =  (Select SUM((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion * isnull(t.Compromete_Compras,0))
			 	   from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Prod_Familias F, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and P.id_familia = F.Id_Familia
				   and I.id_Trans = C.Id_Trans
				   AND P.Id_Iva = TI.Id_Iva
				   And c.Id_Estado_Cbte <> 3
				   AND I.CANTIDAD <> 0
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
	         	   And c.Id_Estado_Cbte <> 3
   	               And T.Compromete_COMPRAS in (1,-1)
		           AND C.FECHA >= @pFecha_Desde 
		           AND C.FECHA < dateadd(dd,1,@pFecha_Hasta))
			END
		ELSE
			BEGIN
               set @Venta_Total =  (Select SUM((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion * isnull(t.Compromete_Compras,0))
			 	   from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Prod_Familias F, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and P.id_familia = F.Id_Familia
				   and I.id_Trans = C.Id_Trans
				   AND P.Id_Iva = TI.Id_Iva
				   And c.Id_Estado_Cbte <> 3
				   AND I.CANTIDAD <> 0
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
	         	   And c.Id_Estado_Cbte <> 3
   	               And T.Compromete_COMPRAS in (1,-1)
				   And C.Id_Proveedor = @pProveedor
		           AND C.FECHA >= @pFecha_Desde 
		           AND C.FECHA < dateadd(dd,1,@pFecha_Hasta))
			END
	  END		   

IF @pProveedor = 0
   BEGIN
       IF @pFamilia = 0
	      BEGIN
			select I.Id_Producto as Producto,P.Descripcion_Detallada as Descripcion ,CAST(Sum(I.Cantidad*T.Compromete_Compras) AS INT) As Cantidad
			    ,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) / @Venta_Total) * 100 as Porcentaje
				 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and I.id_Trans = C.Id_Trans
				   And c.Id_Estado_Cbte <> 3
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
				   AND P.Id_Iva = TI.Id_Iva
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   group by I.Id_Producto,P.Descripcion_Detallada having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
		ELSE 
		   BEGIN
			select I.Id_Producto as Producto,P.Descripcion_Detallada as Descripcion ,CAST(Sum(I.Cantidad*T.Compromete_Compras) AS INT) As Cantidad
			    ,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0))  / @Venta_Total) * 100 as Porcentaje
				 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and I.id_Trans = C.Id_Trans
				   And c.Id_Estado_Cbte <> 3
				   AND P.Id_Iva = TI.Id_Iva
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   AND P.ID_FAMILIA = @pFamilia
				   group by I.Id_Producto,P.Descripcion_Detallada having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
	    END
	ELSE
       IF @pFamilia = 0
	      BEGIN
			select I.Id_Producto as Producto,P.Descripcion_Detallada as Descripcion ,CAST(Sum(I.Cantidad*T.Compromete_Compras) AS INT) As Cantidad
			    ,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0))  / @Venta_Total) * 100 as Porcentaje
				 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and I.id_Trans = C.Id_Trans
				   And c.Id_Estado_Cbte <> 3
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
				   AND P.Id_Iva = TI.Id_Iva
				   AND C.ID_PROVEEDOR = @pProveedor
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   group by I.Id_Producto,P.Descripcion_Detallada having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
		ELSE 
		   BEGIN
			select I.Id_Producto as Producto,P.Descripcion_Detallada as Descripcion ,CAST(Sum(I.Cantidad*T.Compromete_Compras) AS INT) As Cantidad
			    ,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0))  / @Venta_Total) * 100 as Porcentaje
				 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and I.id_Trans = C.Id_Trans
				   And c.Id_Estado_Cbte <> 3
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
				   AND P.Id_Iva = TI.Id_Iva
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   AND C.ID_PROVEEDOR = @pProveedor
				   AND P.ID_FAMILIA = @pFamilia
				   group by I.Id_Producto,P.Descripcion_Detallada having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
   END


 /* 

 SP_compras_por_Producto '20200701','20200831',154,0,0,''
 SP_compras_por_Producto '20200701','20200831',0,0,0,''
 SP_compras_por_Producto '20200701','20200831',1,326,0,'COCI'

 FIN */